package com.abcseo.ws2300;

import java.util.Vector;
import org.apache.log4j.Logger;

import sun.misc.Signal;
import sun.misc.SignalHandler;

/*
 * Program to read and publish data from an LaCrosse 23** series weather station
 *
 * 
 * @author david george
 * 
 * (c) 10-May-2005 David George
 * This program is published under the GNU General Public license
 */
public class OpenJ2300 {
	static Configuration config;

	public static void main(String[] args) 
	{
	
		System.out.println( "OpenJ2300 0.21/PB branch/MySQL logger 2.00 + TCP support 1.0" );
		
		config = Configuration.getInstance();
		
		// all other threads are started from constructor (oooough!)
		@SuppressWarnings("unused")
		WS2300 weatherStation = new WS2300();
		
		// no webserver to initial shutdown listen on SIGINT CTL-C
		new SignalHelper("INT", config);
	}
}

/**
 * <p>
 * Private helper class for <code>SignalInterceptor</code>.
 * </p>
 * 
 * <p>
 * This class exists separately from <code>SignalInterceptor</code> to permit
 * graceful handling of LinkageErrors when the <code>sun.misc.Signal*</code>
 * classes don't exist.
 * </p>
 */
final class SignalHelper implements SignalHandler {
    private final SignalHandler oldHandler;
	private static Logger logger = Logger.getLogger("OpenJ2300/SignalHelper");
    Configuration config;

    SignalHelper(String signame, Configuration config) {
    	this.config = config;
        Signal signal = new Signal(signame);
        oldHandler = Signal.handle(signal, this);

;
    }

    public void handle(Signal sig) {
    	logger.info( "Shutting down OpenJ2300...");
		Vector<WSThread> vt = config.getThreadList();
		
		for (int i = 0; i < vt.size(); i++) {
			WSThread t = vt.get(i);
			t.shutdown();
		}
		logger.info( "OpenJ2300 shutdown complete");
		System.out.flush();
        if (oldHandler != null) {
            oldHandler.handle(sig);
        }
    }
}
